%%%%%%%%%%%%%%%%%%%%%% p10_14.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/15/99 HS
%----------------------------------------------------
%      Problem 10.14: observer-controller design 
%----------------------------------------------------
  clear,clf
  disp('Problem 10.14: observer-controller design')  
  disp('        Lightly-damped modes')  
  disp(' ')
  A = [-0.1 5 0.1; -5 -0.1 5; 0 0 -10];      % state matrix
  B = [ 0; 0; 10];                        % input matrix
  C = [ 1 0 0];                            % output matrix
  D = 0 ;                                 % throughput matrix
  G = ss(A,B,C,D)
  disp('*****>');pause
  p_s = [-1+i*5 -1-i*5 -10]              % desired system poles
  F = place(A,B,p_s)                     % control gain
  disp('*****>');pause
  p_o = [-2 -4 -15]                      % desired observer poles 
  L = place(A',C',p_o)'                  % estimator gain
  disp('*****>');pause
  A_f = A-B*F-L*C                        % controller system matrix
  f_poles = eig(A_f)                     % controller poles
  G_f = ss(A_f,-L,-F,0) 
  f_zeros = tzero(G_f)            % controller zeros
  bode(G_f)
  title('P10.14: System response')
  keyboard
  G_g = G*G_f;
  [Ag,Bg,Cg,Dg]= ssdata(G_g); 				% cascade system
  G_cl = feedback(G_g,1);
  [Acl,Bcl,Ccl,Dcl] = ssdata(G_cl)			 % closed-loop system
  cl_loop_poles = eig(Acl)               % closed-loop system poles
  disp('*****>');pause
  lfg = dcgain(G_cl)
  N = 1/lfg
  T_ref = N*G_cl;
  [AclN,BclN,CclN,DclN] = ssdata(T_ref)
  t = [0:0.02:4]';
  r = 0*t;
  z0 = [0 0 0 1 0 0]'
  [x,y,z] = lsim(T_ref,r,t,z0);
  plot(t,z(:,1:3),t,z(:,4:6),'--'), grid
  title('P10.14: Initial condition response')
  keyboard
  step(T_ref,t)
  grid, title('P10.14: Step input response')
  keyboard  
  disp('end of Reinforcement Problem 10.14')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
