%%%%%%%%%%%%%%%%%%%%%% p10_9.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/15/99 HS
%----------------------------------------------------
%            Problem 10.9: observer design  
%----------------------------------------------------
  clear,clf
  disp('Problem 10.9: observer design')  
  disp('        3rd-order system')  
  disp(' ')
  A = [-4 1 2; 1 -5 3; 2 0 -6];           % state matrix
  B = [ 0; 0; 0];                       % input matrix
  C = [0 1 0];                           % output matrix
  D = 0;                                  % throughput matrix
  G = ss(A,B,C,D)
  disp('*****>');pause
  p_o = [-8 -16 -20]              % desired observer poles 
  L = place(A',C',p_o)'                  % estimator gain
  disp('*****>');pause
  A_ob = A-L*C                      % observer system matrix
  eig(A_ob)                         % check eigenvalues
  disp('*****>');pause
  xo = [1; 0.5; -0.25]                   % initial conditions
  t = [0:0.01:2];                   % time array
  u = 0*t;                          % zero input
  disp('*****>');pause
  [y,x] = lsim(G,u,t,xo);     % simulate system
  disp('Simulate Observer')
  G_ob = ss(A_ob,L,C,D)
  [y_hat,x_hat]=lsim(G_ob,y,t);  % simulate observer
  plot(t,x,'--',t,x_hat)
  grid,title('P10.9: Observer design')
  xlabel('Time (secs)')
  ylabel('System and Observer States')
  keyboard
  plot(t,y,'--',t,y_hat)
  grid,title('P10.9: Observer design')
  xlabel('Time (secs)')
  ylabel('System and Observer Outputs')
  keyboard
  disp('end of Reinforcement Problem 10.9')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
