%%%%%%%%%%%%%%%%%%%%% wif2_3.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%              last revision: 5/23/99 HS
%----------------------------------------------------
%     What If for Example 2.3: does PFE & impulse 
%          response for 3 systems having same 
%     denominator of G(s) but different numerators.
%---------------------------------------------------- 
clear,clf
disp(' What If  for Example 2.3')
  disp('Do partial-fraction expansion to get residues at each pole')
  disp('Effects of changing num of G(s) on residues')
  disp('numerator of G(s) is linear in s')
  numG1 = [3 2]     
  denG = [2 4 5 1]
  disp('*****>');pause
  [resG1,polG1,otherG1] = residue(numG1,denG)
  disp('*****>');pause
  disp('numerator of G(s) is quadratic in s')
  numG2 = [4 3 2]
  [resG2,polG2,otherG2] = residue(numG2,denG)
  disp('*****>');pause
  disp('numerator of G(s) is cubic in s')
  numG3 = [2 8 8 3]
  [resG3,polG3,otherG3] = residue(numG3,denG)
  disp('*****>');pause;
%---------- compute & plot the impulse responses
  subplot(2,2,1)
  impulse(numG1,denG)
  title('WIF2.3: Impulse Response for numG1');grid
  subplot(2,2,2)
  impulse(numG2,denG)
  title('WIF2.3: Impulse Response for numG2');grid
  subplot(2,2,3)
  impulse(numG3,denG)
  title('WIF2.3: Impulse Response for numG3');grid
  keyboard
  subplot(1,1,1)
  disp('end of What If 2.3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%