%%%%%%%%%%%%%%%%%%%%%% cp3_5c.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system  
%      example for Comprehensive Problem CP3.5c
%----------------------------------------------------
clear, clf
disp('Comprehensive Problem 3.5c')
disp('Lead-lag control of hydro-turbine system')

hydro  % read data
disp('*****>'), pause

disp(' ')
disp('Hydro-turbine system with lead-lag controller, alpha = 20.')
disp('Lead zero at s = -3, Lag zero at s = -3/10 = -0.3') 
disp('Kldlg = 10 gives a good response')
disp('... However, you will get large under-shoot also.')
Kldlg = input('enter controller gain Kldlg ==> ');
zlead = -3; zlag = zlead/10;
G = tf(numG,denG)
numleadlag = Kldlg*conv([1  -zlag],[1  -zlead]);
denleadlag = conv([1  -zlag/20],[1  -20*zlead]);
Gleadlag = tf(numleadlag,denleadlag)
OL = Gleadlag*G

disp('Closed-loop system transfer functin ')
T = feedback(OL,1)
[numT,denT] = tfdata(T,'v')
disp('*****>'), pause

disp('Poles of closed-loop system')
pT = roots(denT)
disp('Zeros of closed-loop system')
zT = roots(numT)
disp('DC gain of closed-loop system')
DC_gain = dcgain(numT,denT)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP3.5c: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('end of Comprehensive Problem 3.5c')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

