%%%%%%%%%%%%%%%%%%%%%% p3_17.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/2/99 HS
%----------------------------------------------------
%            Problem 3.17: Gain variation
%----------------------------------------------------
clear, clf
disp(' Problem 3.17: Gain variation')
numG = [1];
denG = conv([1 0],[1 8 32]);
numH = [1 8];
denH = [1 2];
H = tf(numH,denH);
K = [1 10 100 1000];
for i = 1:4
   numGK = K(i)*numG;
   G = tf(numGK,denG);
   T = feedback(G,H)
   [zT,pT,kT] = zpkdata(T,'v');
   disp('feedback system zeros and poles for gain')
   k = num2str(K(i))
   zT
   pT
   disp('*******>');pause 
   t = [0:0.04:40];
   subplot(2,2,i);
   y = step(T,t);
   plot(t,y)
   xlabel('Time (sec.)')
   ylabel('y')
   title(['K = ', num2str(K(i))])
   hold on;
   grid;
end

subplot(2,2,1), hold on
axis([0 40 0 0.25])
subplot(2,2,2), hold on
axis([0 4 0 0.4])
subplot(2,2,3), hold on
axis([0 4 -4 4])
subplot(2,2,4), hold on
axis([0 4 -1e6 1e6])
keyboard
subplot(1,1,1)
disp('end of Reinforcement Problem 3.17')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
