%%%%%%%%%%%%%%%%%%%%%% p3_18.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/2/99 HS
%----------------------------------------------------
%  Problem 3.18: Gain variation for 2nd-order system
%----------------------------------------------------
clear,clf
disp(' Problem 3.18: Gain variation for 2nd-order system')
numG = [1 5]
denG = conv([1 1],[1 3])
pG = roots(denG)
disp('*******>');pause
numH = [1]
denH = [1]
H = tf(numH,denH)
pH = roots(denH)     % poles of H
disp('*******>');pause
K = [1 10 100 1000]
for i = 1:4
    numGK = K(i)*numG
    G = tf(numGK,denG)
   T = feedback(G,H)
   [zT,pT,kT] = zpkdata(T,'v');
   disp('feedback system zeros and poles for gain')
   k = num2str(K(i))
   zT
   pT
   disp('*******>');pause 
   t = [0:0.02:2];
   subplot(2,2,i)
   y = step(T,t);
   plot(t,y)
   xlabel('Time (sec.)')
   ylabel('y')
   title(['K = ', num2str(K(i))])
   grid
end

subplot(2,2,1)
axis([0 1.5 0 1.2])
subplot(2,2,2)
axis([0 1.5 0 1.2])
subplot(2,2,3)
axis([0 0.5 0 1.2])
subplot(2,2,4)
axis([0 0.5 0 1.2])
keyboard
subplot(1,1,1)
disp('end of Reinforcement Problem 3.18')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
