%%%%%%%%%%%%%%%%%%%%%% cp5_2a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%       Comprehensive Problem CP5.2a
%	     satellite + P-only control
%----------------------------------------------------
disp('CP5.2A: Satellite with proportional control')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
disp(' ')
disp('Have created model for satellite with P-only control')
num = numG1;	% rename to agree with Scripts in book
den = denG1;
G = tf(num,den)
disp('draw root locus for K > 0')
rlocus(G);grid
axis('equal')
title('CP5.2a: Satellite with P-only ctrl, locus for K > 0')
disp('branch in RHP ==> unstable for all K > 0')
keyboard
%--- step response of unity-feedback closed-loop system
G_CL = feedback(0.001*G,1)
step(G_CL);grid
title('CP5.2a: Closed-loop step response for K = 0.001')
keyboard
%==================== K < 0 ============
disp('draw 0-degree locus ==> K < 0')
rlocus(-G);grid
title('CP5.2a: Satellite with P-only ctrl, locus for K < 0')
axis('equal')
disp('both branches in LHP ==> stable for all K < 0')
keyboard
%--- step response of unity-feedback closed-loop system
%  Reduce magnitude of gain to slow down response
%  but stable for large gains also
G_CL = feedback(-0.001*G,1)
step(G_CL,1000);grid
title('CP5.2a: Closed-loop step response for K = -0.001')
disp('end of Comprehensive Problem 5.2a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

