%%%%%%%%%%%%%%%%%%%%%% p5_11.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%                   Problem 5.11:
%              root locus with tau varied
%
%                      K (0.2s+1)
%     G(s) = -----------------------------------
%            (tau s+1)(s^2 + 2 zeta wn s + wn^2)
%----------------------------------------------------
clear,clf
%   do locus for  K=10, zeta=0.2, wn=5 
%       and 0.5 <= tau <= 8
K=10
wn=5
zeta=0.2
num=K*[0.2 1]

clpoles = []; param = []
for tau = 0.5:0.5:8,
   den = conv([tau 1],[1  2*zeta*wn  wn^2]);
   clpoly = [0 0 num] + den;  % form closed-loop char poly
   clp = roots(clpoly);  % calc closed-loop poles
   clpoles = [clpoles; clp'];
   param = [param;tau];
end
disp('values of tau and CL poles are:')
disp([param clpoles])
disp('****>')
pause
axis('square')
axis([-10 2 -6 6]);
plot(clpoles,'*')
grid;title('P5.11: Varying time constant')
xlabel('Real Axis')
ylabel('Imag Axis')
disp('end of Reinforcement Problem 5.11')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%