%%%%% fig7_2a.m %%%%% 
%	Jan. 1999
%  last revision: 1/2/99  JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 7.2a: Command step response for Example 7.1: ')
  denGp = conv(conv([1 0.01],[1 1]),[1 20])
  Gp = tf(1,denGp)
  G  = 50*Gp   % Gc(s) = 50
  T = feedback(G,1)  % unity feedback
  t = [0:0.05:20]';
  yr = step(T,t);
  clf, plot(t,yr); grid
  ylabel('Amplitude');xlabel('Time (sec.)')
  %title('fig 7.2a: Command step response of third order system')
  [Mo,tp,tr,ts,ess] = tstats(t,yr,1.0);
  text(8,0.42,['overshoot = ' num2str(Mo) ' %'])
  text(8,0.34,['time to peak = ' num2str(tp) ' s'])
  text(8,0.26,['rise time = ' num2str(tr) ' s'])
  text(8,0.18,['2% settling time = ' num2str(ts) ' s'])
  text(8,0.10,['steady-state error = ' num2str(ess) ' %'])
  print -deps fig7_2a.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%