%%%%%%%%%%%%%%%%%%%%%% p7_3.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%     Problem 7.3: simulate step response to find
%      overshoot, rise time, settling time, and 
%                steady-state error
%----------------------------------------------------
  clear,clf
  disp('Problem 7.3: find system step-response performance')
  disp('overshoot, rise time, settling time, & steady-state error')  
  disp(' ')
  numGp = [1 1]
  denGp = conv([1 0.1],[1 3 25])
  Gp = tf(numGp,denGp)
  Gcp = 60*Gp
  disp('*****>');pause
  Tr = feedback(Gcp,1)
  t = [0:0.1:30]';
  y = step(Tr,t);
  clf, plot(t,y); grid
  ylabel('amplitude');xlabel('Time (sec)')
  title('P7.3: Step response of third order system')
  [mo,tp,tr,ts,ess] = tstats(t,y,1.0);
  text(2,0.30,['overshoot = ' num2str(mo) ' %'])
  text(2,0.25,['time to overshoot = ' num2str(tp) ' s'])
  text(2,0.20,['rise time = ' num2str(tr) ' s'])
  text(2,0.15,['2% settling time = ' num2str(ts) ' s'])
  text(2,0.10,['steady-state error = ' num2str(ess) ' %'])
  damp(Tr)
  [numTr,denTr] = tfdata(Tr,'v')
  [resS,polS,otherS] = residue(numTr,[denTr 0])
  keyboard
  Td = feedback(Gp,60)
  step(Td,t)
  grid
  title('P7.3: Disturbance response of third-order system')
  keyboard
  disp('end of Reinforcement Problem 7.3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%