%%%%%%%%%%%%%%%%%%%%%% p7_5.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%          Problem 7.5: find Kp and Kv, and 
%          simulate step and ramp responses
%----------------------------------------------------
clear,clf
  disp('Problem 7.5: Steady-state regulation')
  disp('  Find Kp and Kv, and simulate step and')
  disp('  ramp responses')
  disp(' ')
  numGp = 6*[1 1]                            % generate G(s)
  denGp = conv([1 0],[1 4 4])
  Gp = tf(numGp,denGp)
  disp('*****>');pause
  G = 5*Gp										     % compensated system
  Kp = dcgain(G)                      		% position error constant
  disp('*****>');pause	
  Kv = vgain(G)                       		% velocity error constant
  disp('*****>');pause
  disp('Close system loop and see step response')
  T = feedback(G,1)          					  % closed-loop system
  t = [0:0.05:10]';                         % time
  ystep = step(T,t);        				     % step response
  plot(t,[ones(size(t)) ystep])
  title('P7.5: Step response')
  xlabel('time in seconds')
  ylabel('response')
  grid
  keyboard
  disp('See ramp response')
  t = [0:0.05:20]'; u = t;                  % time and unit ramp
  yramp = lsim(G,u,t);          				  % ramp response
  plot(t,[t yramp])
  title('P7.5: Ramp response')
  xlabel('time in seconds')
  ylabel('response')
  grid
  keyboard
  disp('end of Reinforcement Problem 7.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%