%%%%%%%%%%%%%%%%%%%%% wif8_1.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/22/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  						Example 8.1
%----------------------------------------------------
clear,clf
y = 'y'; n = 'n';
command = y;
disp('What-If 8.1: Proportional control')
disp('find smallest KP to get tr <= 1.0 s and yss >= 0.9')
%----- plant & sensor parameters
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
numGp = Kproc;
denGp = conv([tauP1 1],[tauP2 1]);
Gp = tf(numGp,denGp)
denH = [tau_sen 1];
H = tf(1,denH)
%
%---- closed-loop step response to reference input
t = [0:0.02:10]';
%
while command == y,
  KP = input('enter value for KP ==> ');
  KP_str = num2str(KP);
  T = feedback(KP*Gp,H,-1);
  ys = step(T,t);
  ref = 1;
  [Mo,tp,tr,ts,ess] = tstats(t,ys,ref);
  disp(['10%-90% rise time is ' num2str(tr) ' s'])
  disp(['The reference level is ' num2str(ref) ])
  disp(['steady state error is ' num2str(ess) ' %'])
  plot(t,ys);grid
  xlabel('Time (s)'),ylabel('output')
  title('WIF8.1: CL step resp, Prop control')
  text('Units','norm','Pos',[0.5 0.2],...
		'Str',['KP = ' KP_str])
command = input('run another case? (y/n) ==> ');
end
disp('end of What If 8.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
