%%%%%%%%%%%%%%%%%%%%% wif8_2b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/16/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  						Example 8.2
%----------------------------------------------------
clear,clf
disp('Wif 8.2b: PI control with ramp inputs')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
disp('Plant transfer functon:')
Gp    = tf(Kproc,denGp)
disp('Sensor transfer function:')
H     = tf(1,[tau_sen 1])

%=========== reference input ===========
KP = 0.6;	% selected for 10% overshoot
KP_str=num2str(KP);
KI = 0.5;
KI_str=num2str(KI);
Kc = tf(KP*[1 KI],[1 0]);
[T_ref] = feedback(Gp*Kc,H,-1);
t = [0:0.02:10];
u = t;
y_ref = lsim(T_ref,u,t);

%=========== repeat for disturbance input ===========
T_dist = feedback(Gp,-Kc*H,+1);
y_dist = lsim(T_dist,u,t);
%-------- plot both responses
disp('Plot CL response to ramp reference and disturbance inputs')
disp('*******>');pause
plot(t,y_ref,'--',t,y_dist,'-.',t,u)
axis([0 10 0 10])
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
title('Wif 8.2b: CL ref & dist ramp responses, P-I control')
text(6.05,1.55,['KP = ' KP_str])
text(6.05,1.05,['KI = ' KI_str])
text(7.0,5.9,'reference')
text(6.0,3.5,'disturbance')
keyboard
disp('end of What If 8.2b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%