%%%%%%%%%%%%%%%% fig9_4.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.4: Lag control, Ex. 9.1')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4; 
Klag = 0.924;
Zlag = -0.25;
Alag = 13.27;
%----- 
Zlag_str=num2str(Zlag);
Klag_str=num2str(Klag);
Alag_str = num2str(Alag);
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]));
H  = tf(1,[tau_sen 1]);
Gc = tf(Klag*[1 -Zlag],[1 -Zlag/Alag]);	
%---- CL step response to reference input
T_ref = feedback(Gc*Gp,H,-1);
t = [0:0.02:10];
y_ref = step(T_ref,t);
%
%=========== repeat for disturbance input ===========
T_dist = feedback(Gp,-Gc*H,+1)
y_dist = step(T_dist,t);
%
%-------- plot both responses
plot(t,y_ref,t,y_dist,'--')
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
% title('fig 9.4: CL ref & dist step resp,lag, EX. 9.1')
text(7.0,0.75,['Klag = ' Klag_str])
text(7.0,0.68,['Zlag = ' Zlag_str])
text(7.0,0.61,['Alag = ' Alag_str])
text(6.0,1.00,'reference')
text(3.0,0.62,'disturbance')
axis([0 10 0 1.2])
print -deps fig9_4.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%