%%%%%%%% fig9_8.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.8: Bode plots for Example 9.3')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]))
H  = tf(1,[tau_sen 1])
GpH = Gp*H
Klead = 6; Zlead = -1.995; Alead = 27.52;
Gc = tf(Klead*Alead*[1  -Zlead],[1  -Alead*Zlead]);
%----------
w = logspace(-2,3,100);
ph180 = -180*ones(length(w));
%----- first do gain-only case
[mag_K,ph_K] = bode(Klead*GpH,w);
mag_K = reshape(mag_K,100,1);
ph_K  = reshape(ph_K, 100,1);
mag_db_K = 20*log10(mag_K);
%
%-------- do calcs with final lead design
Gc = tf(Klead*Alead*[1  -Zlead],[1  -Alead*Zlead]) % use (9.1) for lead TF
GcGpH = Gc*GpH;
[mag_lead,ph_lead] = bode(GcGpH,w);
mag_lead = reshape(mag_lead,100,1);
ph_lead  = reshape(ph_lead, 100,1);
mag_db_lead = 20*log10(mag_lead);
%--------- now plot both sets
subplot(211)
semilogx(w,mag_db_lead,w,mag_db_K,'--');grid;
xlabel('Frequency (rad/sec)')
ylabel('Gain dB')
% title('fig 9.8: lead design for Ex. 9.2')
axis([0.01 1000 -100 50])
text(100,-25,'Lead')
text(3,-65,'Proportional')
subplot(212)
semilogx(w,ph_lead,'-',w,ph_K,'--',w,ph180,':');
grid
xlabel('Frequency (rad/sec)')
ylabel('Phase deg')
axis([0.01 1000 -300 0])
text(20,-130,'Lead')
text(1.0,-240,'Proportional')
print -deps fig9_8.eps
subplot(111)	% reset plot window
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%